function ms=addmut(M,mu)
%function ms=addmut(M,mu)
%returns a matrix with nloc cols simulating the MS state of each node in M, starting with zero for root.
%mu is a vector length nloc with the mutation rate, in whatever units time is measured in.
%M defined as:
%First n rows = terminal nodes
%Next (n-1) rows = internal nodes.
%First col = time (going backwards) in whatever units, since start
%2nd col =  index of father
%3rd col = index of right descendent
%4th col = index of left descendent

%Note that nodes n+1..2n-1 are ordered in temporal order
%This means we can simply step backwards down the list of nodes

[n xxx]=size(M);  n=ceil(n/2);   %note 2n-1 is always odd
nloc=length(mu);
ms=zeros(2*n-1,nloc);
mu=mu./2;    %divide by two because up and down steps are separate

for i=(2*n-2):-1:1
t=M(M(i,2),1) - M(i,1);
for j=1:nloc
  ms(i,j) = ms(M(i,2),j) +rpois(mu(j)*t) -rpois(mu(j)*t);
end
end
